/* ------------------------------------------------------------------------------------------------------*/
/* - BasicTPR.h                                                                                          */
/* - **********                                                                                          */
/* -                                                                                                     */
/* - Implizite Darstellung von Paaren von flatterms durch die Stelle ihrer Ueberlappung.                 */
/* -                                                                                                     */
/* - 01.04.96 Arnim. Angelegt.                                                                           */
/* -                                                                                                     */
/* -                                                                                                     */
/* ------------------------------------------------------------------------------------------------------*/

#ifndef BASICTPR_H
#define BASICTPR_H

#include "InfoStrings.h"
#include "TermOperationen.h"
#include "RUndEVerwaltung.h"
#include "SUEBasis.h"

#ifdef __cplusplus
extern "C" {
#endif



/* ------------------------------------------------------------------------------------------------------*/
/* ------- Initialize------------------------------------------------------------------------------------*/
/* ------------------------------------------------------------------------------------------------------*/

BOOLEAN BTP_InitAposteriori(InfoStringT DEF, InfoStringT USR);


/* ------------------------------------------------------------------------------------------------------*/
/* ------- New Flats generated --------------------------------------------------------------------------*/
/* ------------------------------------------------------------------------------------------------------*/

void BTP_NewFlatsGenerated(void);


/* ------------------------------------------------------------------------------------------------------*/
/* ------- FLATTERMS to TERMPAIR ------------------------------------------------------------------------*/
/* ------------------------------------------------------------------------------------------------------*/
                                                                                                         
TermpairT BTP_Flat2TP(TermT lhs, TermT rhs, RegelOderGleichungsT father, RegelOderGleichungsT mother,
                      UTermT actualPosition, PCL_ObjektNummerT pclID);
                                                                                                         
/* ------------------------------------------------------------------------------------------------------*/
/* ------- TERMPAIR to PARALLEL -------------------------------------------------------------------------*/
/* ------------------------------------------------------------------------------------------------------*/
                                                                                                         
void BTP_Tp2Par(TermpairT tp, TermT *lhs, TermT *rhs, RegelOderGleichungsT father, 
                RegelOderGleichungsT mother, PCL_ObjektNummerT *pclIDPtr);
                                                                                                         
/* ------------------------------------------------------------------------------------------------------*/
/* ------- PARALLEL to FLATTERMS ------------------------------------------------------------------------*/
/* ------------------------------------------------------------------------------------------------------*/

void BTP_Par2Ft(TermpairT tp, TermT lhs, TermT rhs, RegelOderGleichungsT father, 
                    RegelOderGleichungsT mother);
/* Destroys the termpair-representation irrecoverable */


/* ------------------------------------------------------------------------------------------------------*/
/* ------- PARALLEL to TERMPAIR -------------------------------------------------------------------------*/
/* ------------------------------------------------------------------------------------------------------*/
                                                                                                         
TermpairT BTP_Par2TP(TermpairT tp, TermT lhs, TermT rhs, RegelOderGleichungsT father, 
                     RegelOderGleichungsT mother, BOOLEAN HasChanged,
                     PCL_ObjektNummerT pclID);
                                                                                                         
                                                                                                         
/* ------------------------------------------------------------------------------------------------------*/
/* ------- DESTROY --------------------------------------------------------------------------------------*/
/* ------------------------------------------------------------------------------------------------------*/
                                                                                                         
                                                                                                         
void      BTP_DestroyTP  (TermpairT tp, RegelOderGleichungsT father, RegelOderGleichungsT mother);
/* Termpaar zerstoeren */                                                                                
                                                                                                         
void      BTP_DestroyPar (TermpairT tp, TermT lhs, TermT rhs, RegelOderGleichungsT father, 
                          RegelOderGleichungsT mother);
/* Termpaar und Flachterme zerstoeren */                                                                 
                                                                                                         
                                                                                                         
/* ------------------------------------------------------------------------------------------------------*/
/* ------- TermVerfolgung -------------------------------------------------------------------------------*/
/* ------------------------------------------------------------------------------------------------------*/

void BTP_TermOperationBeiVerfolgung(void (* Operation) (TermT, TermT), TermpairT tp,
                                    RegelOderGleichungsT father, RegelOderGleichungsT mother);

/* ------------------------------------------------------------------------------------------------------*/
/* ------- Unambiguous Comparison -----------------------------------------------------------------------*/
/* ------------------------------------------------------------------------------------------------------*/

BOOLEAN BTP_UnambiguousGreaterThan(TermpairT tp1, RegelOderGleichungsT father1, RegelOderGleichungsT mother1,
                                   TermpairT tp2, RegelOderGleichungsT father2, RegelOderGleichungsT mother2);
/* Vom Entstehungszeitpunkt unabhaengiger Vergleich von Termpaaren.
   Hier: Eltern-Nummern dann SymbLex
*/

/* ------------------------------------------------------------------------------------------------------*/
/* ------- Statistics -----------------------------------------------------------------------------------*/
/* ------------------------------------------------------------------------------------------------------*/
                                                                                                         
#define BTP_Statistics(IS)
                                                                                                         
/* ------------------------------------------------------------------------------------------------------*/
/* ------- Output ---------------------------------------------------------------------------------------*/
/* ------------------------------------------------------------------------------------------------------*/
                                                                                                         
void BTP_PrintTermpair (TermpairT tp, RegelOderGleichungsT father, RegelOderGleichungsT mother, const char *trenner);
                                                                                                         
                                                                                                         
/* ------------------------------------------------------------------------------------------------------*/
/* ------------ CLEANING WOMAN --------------------------------------------------------------------------*/
/* ------------------------------------------------------------------------------------------------------*/

#define BTP_CleanUp()

#ifdef __cplusplus
}
#endif
#endif /* BASICTPR_H */
