#ifndef C_STATISTICS_H
#define C_STATISTICS_H


#include "general.h"
#include "SUEBasis.h"
#include "InfoStrings.h"

#ifdef __cplusplus
extern "C" {
#endif


/* 1. Time-Distribution */
/* -------------------- */
/* Alle berechneten Gewichte melden mit CS_BerechnetesGewichtIst_Stat.
   Dann mit CS_TimeDistribution Statistik ausgeben.
*/

extern void (* CS_BerechnetesGewichtIstProc)(long int);

#define CS_BerechnetesGewichtIst(n) ((* CS_BerechnetesGewichtIstProc)(n))


void CS_TimeDistribution(InfoStringT IS);


/* 2. Weight-Distribution */
/* ---------------------- */

/* Verteilung in aktueller Menge. Dazu Durchlauf durch KP-Menge.
   */

void CS_WeightStatisticsStart(InfoStringT StatisticsIS);
extern PQ_WatchingWalkthroughProcedureT CS_WeightStatProc;
void CS_WeightStatisticsEnd(void);


/* 3. Initialize */
/* ------------- */

BOOLEAN CS_InitAposteriori (InfoStringT DEF, InfoStringT USR);

void CS_ParamInfo(ParamInfoArtT what, InfoStringT DEF, InfoStringT USR);

void    CS_CleanUp(void);



#ifdef __cplusplus
}
#endif

#endif
