/**********************************************************************
* Filename : CritGoals.h
*
* Kurzbeschreibung : Verwalten der Kritischen Ziele
*
* Autoren : WEC
*
* 08.12.96: Erstellung aus SUEM.c heraus
*
*
* Benoetigt folgende Module:
*
* Benutzte Globale Variablen aus anderen Modulen:
*
**********************************************************************/

#ifndef CRITGOALS_H
#define CRITGOALS_H

#include "general.h"
#include "TermpairRepresentation.h"
#include "InfoStrings.h"

#ifdef __cplusplus
extern "C" {
#endif


void CG_Insert (TermpairT tp, WeightEntryT wt, RegelOderGleichungsT aP, RegelOderGleichungsT oP);
/* Einzelne Gleichung aufnehmen */

BOOLEAN CG_Select(TermpairT *tpPtr, RegelOderGleichungsT *aPPtr, RegelOderGleichungsT *oPPtr);

/* Erzwingen=FALSE:  IR wird entsprechend durchgefuehrt, falls Stichpunkt oder Periode erreicht.
   Erzwingen=TRUE: IR wird mit Staerke durchgefuehrt
*/

extern BOOLEAN (*CG_SelectProc)(TermpairT*,RegelOderGleichungsT*,RegelOderGleichungsT*);   /* analog PQ_SelectProc */

void CG_CGMengeInterreduzieren(BOOLEAN Erzwingen, char *Staerke);
  
void CG_KillParent(RegelOderGleichungsT re);

void CG_CleanUp (void);

void CG_SoftCleanUp(void);

void CG_Statistics (InfoStringT IS);

BOOLEAN CG_InitAposteriori (InfoStringT DEF, InfoStringT USR);


#ifdef __cplusplus
}
#endif

#endif /* CRITGOALS_H */
