/*
Dieses Modul dient dem Initialisieren aller Strukturen nach dem Einlesen einer Spezifikation.

28.02.94 Angelegt.Arnim.

*/

#ifndef INITS_H
#define INITS_H

#ifdef __cplusplus
extern "C" {
#endif

/* -------------------------------------------------------*/
/* ------------- Defines ---------------------------------*/
/* -------------------------------------------------------*/



/* -------------------------------------------------------*/
/* ------------- Funktionen ------------------------------*/
/* -------------------------------------------------------*/

/* Folgende Annahmen muessen beim Gebrauch der folgenden Funktionen erfuellt sein:
   1. IN_AllesAprioriInitialisieren wird vor IN_NeueSpezifikation aufgerufen,
   2. Die in IN_AllesAprioriInitialisieren aufgerufenen Initialisierungen koennen auf die eingestellten
      Aufruf-Optionen (ueber Parameter.h) zurueckgreifen, aber NICHT auf die eingelesene Spezifikation,
   3. Wenn IN_NeueSpezifikation aufgerufen wird, muessen alle Module bereits soweit initialisiert sein,
      dass sie nur noch auf die Daten aus der Spezifikation warten.
*/

void IN_AllesAprioriInitialisieren(void);
/* Diese Funktion ermoeglicht das Besetzen von Spezifikations-unabhaengigen
   Daten innerhalb eines Moduls. Diese Prozedur wird VOR dem Einlesen der
   Spezifikation und NACH dem Auswerten der Parameter beim Programmaufruf
   ausgefuehrt.
*/

void IN_SpezifikationEinlesen(char *filename);
/* Nur Spezifikation einlesen, damit extModus bekannt wird. */

void IN_AllesAposterioriInitialisieren(void);
/* Einparsen der neuen Spezifikation, Initialisieren der einzelnen Module etc. 
   In dieser Prozedur wird jedem Modul die Moeglichkeit gegeben, interne Daten
   aus der eingelesenen Spezifikation auszuwerten und zu sichern,
   bevor anschliessend diese Spezifikation wieder freigegeben werden kann.
   */

void IN_SpezifikationGelesen(void);
/* Eingelesene Strukturen freigeben. */

#ifdef __cplusplus
}
#endif

#endif

