/*=================================================================================================================
  =                                                                                                               =
  =  KPBildung.h                                                                                                  =
  =                                                                                                               =
  =  Bildung von kritischen Paaren zwischen Regeln, Gleichungen und untereinander                                 =
  =                                                                                                               =
  =  24.06.94  Arnim.                                                                                             =
  =================================================================================================================*/
#ifndef KPBILDUNG_H
#define KPBILDUNG_H

#include "TermOperationen.h"
#include "RUndEVerwaltung.h"

#ifdef __cplusplus
extern "C" {
#endif


/* -------------------------------------------------------------------------------*/
/* --------------- KPBildung Starten, KPs in KP-Menge aufnehmen ------------------*/
/* -------------------------------------------------------------------------------*/

void KPB_ParamInfo(ParamInfoArtT what, InfoStringT DEF, InfoStringT USR);

BOOLEAN KPB_InitAposteriori(InfoStringT DEF, InfoStringT USR);


extern void (* KPBehandlungsProcFATHER) (RegelOderGleichungsT, TermT, TermT, UTermT);
extern void (* KPBehandlungsProcMOTHER) (RegelOderGleichungsT, TermT, TermT, UTermT);
extern void (* KPBehandlungsProcIROpfer) (TermT, TermT);

#define /*void*/ KPB_GebildetesKPBehandelnMitMutter(mother, lhs, rhs, actualPosition)\
( (* KPBehandlungsProcMOTHER) (mother, lhs, rhs, actualPosition))

#define /*void*/ KPB_GebildetesKPBehandelnMitVater(father, lhs, rhs, actualPosition)\
( (* KPBehandlungsProcFATHER) (father, lhs, rhs, actualPosition))

#define /*void*/ KPB_IROpferBehandeln(lhs, rhs)\
( (* KPBehandlungsProcIROpfer) (lhs, rhs))

void KPB_KonklusionenAbarbeiten(RegelOderGleichungsT r);
/* Meldet die entsprechende Regel oder Gleichung dem Datenbankexperten an und
   verarbeitet die gezogenen Schlussfolgerungen.
*/

/**************** Fuer Teamwork: *****************/
void KPB_KeineBehandlung(void);
void KPB_WiederBehandeln(void);
char *KPB_ArtBehandlung(void);


#ifdef __cplusplus
}
#endif

#endif
