/* -------------------------------------------------------------------------------------------------------------*/
/* -                                                                                                            */
/* - KPHeap.h                                                                                                   */
/* - ********                                                                                                   */
/* -                                                                                                            */
/* - Enthaelt die Operationen zur Verwaltung der Priority Queue als normalen Heap.                              */
/* -                                                                                                            */
/* - 20.03.96 Neu eingerichtet. Arnim.                                                                          */
/* -                                                                                                            */
/* -------------------------------------------------------------------------------------------------------------*/
#ifndef KPHEAP_H
#define KPHEAP_H


#include "general.h"
#include "InfoStrings.h"

#include "TermpairRepresentation.h"
#include "SUEBasis.h"

#include "RUndEVerwaltung.h"

#ifdef __cplusplus
extern "C" {
#endif


/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Initialize ------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

BOOLEAN KPH_InitAposteriori(InfoStringT DEF, InfoStringT USR);


/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Insert ----------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void KPH_INSERT (TermpairT, WeightEntryT, RegelOderGleichungsT, RegelOderGleichungsT);
extern void (* KPH_INSERTImmortal)   (TermpairT, WeightEntryT, RegelOderGleichungsT, RegelOderGleichungsT);

BOOLEAN KPH_POSTPONE (TermpairT, WeightEntryT, RegelOderGleichungsT, RegelOderGleichungsT);


/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Select ----------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

BOOLEAN KPH_SELECT (TermpairT *, RegelOderGleichungsT *, RegelOderGleichungsT *);

BOOLEAN KPH_SELECTINITIAL (TermpairT *, RegelOderGleichungsT *, RegelOderGleichungsT *);


/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Parents ---------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void KPH_NEWPARENT(RegelOderGleichungsT re);

void KPH_KILLPARENT(RegelOderGleichungsT re);

void KPH_REDIRECTPARENT(void);

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Walkthrough -----------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void KPH_WALKTHROUGH (PQ_WalkthroughProcedureT AP, BOOLEAN NeedsTerms);

void KPH_WATCHINGWALKTHROUGH(PQ_WatchingWalkthroughProcedureT AP);

void KPH_TermVerfolgung (void (* OperationAufTermen) (TermT, TermT));

unsigned long int KPH_AnzKPsToGo(void);

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Statistics ------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void KPH_STATISTICS(InfoStringT is);
/* output    -- Ausgabe der KP-Menge
   limit=... -- bis hoechstens Gewicht ...
*/
void KPH_ActSize(unsigned long int *AktKPZahl, unsigned long int *AktGueltigeKPZahl);

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Clean up --------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void KPH_SoftAbraeumen(void);
void KPH_Abraeumen(void);
/* Alles loeschen*/


#ifdef __cplusplus
}
#endif

#endif
