/*=================================================================================================================
  =                                                                                                               =
  =  KPMengenInterreduktion.h                                                                                     =
  =                                                                                                               =
  =  Interreduktion/Subsumption der KP-Menge                                                                      =
  =                                                                                                               =
  =  27.03.96  Arnim. Aus der Interreduktion ausgegliedert.                                                       =
  =================================================================================================================*/
#ifndef KPMENGENIR_H
#define KPMENGENIR_H

#include "general.h"
#include "InfoStrings.h"

#ifdef __cplusplus
extern "C" {
#endif

/* -------------------------------------------------------------------------------*/
/* --------------- Interreduktion der KP-Menge -----------------------------------*/
/* -------------------------------------------------------------------------------*/

void KPIR_KPMengeInterreduzieren(void);
/* Interreduktion der KP-Menge gemaess Aufruf-Einstellung.*/


void KPIR_Wahlfrei(char *howStrong);
/* Fuehrt die KP-Mengen-Interreduktion zu einem beliebigen Zeitpunkt aus.
   Funktionalitaet(Maechtigkeit und dyn. Neubewerten)  wie beim Programm-Start
   vorgesehen.
   howStrong = [res]
*/

/* -------------------------------------------------------------------------------*/
/* --------------- Initialisierung -----------------------------------------------*/
/* -------------------------------------------------------------------------------*/

void KPIR_ParamInfo(ParamInfoArtT what, InfoStringT DEF, InfoStringT USR);

BOOLEAN KPIR_InitAposteriori(InfoStringT DEF, InfoStringT USR);
/* Syntax des Info-Strings:
   period=<periode>[res]:[res]=<stichpunkt>.<stichpunkt>.<stichpunkt>:[res]=<stichpunkt>.<stichpunkt>...[:statistik]

   Beispiel:
   r=100:period=500res:e=150.200.300:statistik

   Default ist: ""

   Die den Zeitpunkt der KPMengen-IR bezeichnenden Zahlen beschreiben die bis dahin insgesamt enstandenen
   Regeln und Gleichungen, sind also eindeutig.
   
   "statistik" gibt an, ob waehrend der KP-Mengen-IR Informationen gesammelt werden sollen.

*/


void KPIR_Statistik(InfoStringT IS);
/* Ausgabe der hier gewonnen Ergebnisse. */

#ifdef __cplusplus
}
#endif

#endif
