/**********************************************************************
* Filename : MNF_Classify.h
*
* Kurzbeschreibung : Classifizieren von Nachfolgermengen bei Generate
*
* Autoren : Andreas Jaeger
*
* 02.10.96: Erstellung
*
* Leider hat das Modul einen ganzen Haufen von globalen Variablen,
* die in MNF_ClassifyInitFunc initialisiert werden, in
* MNF_ClassifyTraverseFunc veraendert werden
* und letztendlich in MNF_ClassifyExitFunc gebraucht werden um die
* exportierten globalen Variablen zu setzen.
*
*
**********************************************************************/

#ifndef MNF_CLASSIFY_H
#define MNF_CLASSIFY_H

#include "TermOperationen.h"

#ifdef __cplusplus
extern "C" {
#endif


extern unsigned long MNFC_WeightLeft, MNFC_WeightRight;
extern unsigned long MNFC_IrredLeft, MNFC_IrredRight;
extern unsigned long MNFC_WeightHarmLeft, MNFC_WeightHarmRight,
   MNFC_WeightGeoLeft, MNFC_WeightGeoRight,
   MNFC_MinWeightLeft, MNFC_MinWeightRight,
   MNFC_MaxWeightLeft, MNFC_MaxWeightRight;

void MNF_ClassifyInitFunc (BOOLEAN AbbruchDeckel);

void MNF_ClassifyTraverseFunc (TermT term, BOOLEAN irreduzibel, BOOLEAN links);
   

void MNF_ClassifyExitFunc (void);


#ifdef __cplusplus
}
#endif

#endif /* MNF_CLASSIFY_H */

