/**********************************************************************
* Filename : MNF_Ziele.h
*
* Kurzbeschreibung : Zielbehandlung mit MultipleNormalFormen
*
* Autoren : Andreas Jaeger
*
* 09.10.96: Erstellung
*
**********************************************************************/

#ifndef MNF_ZIELE_H
#define MNF_ZIELE_H

#include "InfoStrings.h"
#include "RUndEVerwaltung.h"
#include "TermOperationen.h"
#include "Zielverwaltung.h"
#include "Zielverwaltung_private.h"

#ifdef __cplusplus
extern "C" {
#endif



BOOLEAN MNFZ_InitAposteriori(InfoStringT DEF, InfoStringT USR);

void MNFZ_ParamInfo(ParamInfoArtT what, InfoStringT DEF, InfoStringT USR);

void MNFZ_Statistik(InfoStringT str);

void MNFZ_ZielEinfuegen (ZieleT * ziel);

void MNFZ_LoeschePrivateData (ZieleT *ziel);

void MNFZ_AusgabeZiel (ZieleT * ziel, Z_AusgabeArtT Z_AusgabeArt);
   
void MNFZ_ZielBeobachtung (ZieleT *ziel, Z_BeobachtungsDurchlaufProcT AP);

BOOLEAN MNFZ_TesteZielErledigt (ZieleT *ziel);

BOOLEAN MNFZ_ZielErledigtMitNeuerRegel (ZieleT *ziel, RegelT Regel,
                                        BOOLEAN expand);

BOOLEAN MNFZ_ZielErledigtMitNeuerGleichung (ZieleT *ziel, GleichungsT Gleichung,
                                            BOOLEAN expand);
BOOLEAN MNFZ_ZielFinalerDurchlauf (ZieleT * ziel);

void MNFZ_InitZielBeobachtungsProz (ZieleT  *ziel);


#ifdef __cplusplus
}
#endif

#endif /* MNF_ZIELE_H */
