/* -------------------------------------------------------------------------------------------------------------*/
/* -                                                                                                            */
/* - NewClassification.h                                                                                        */
/* - ****************                                                                                           */
/* -                                                                                                            */
/* - Schnittstelle der Klassifikationsroutinen fuer SUEM.                                                       */
/* -                                                                                                            */
/* - 14.03.96 Arnim. Angelegt.                                                                                  */
/* - 24.04.98 Andreas: Umbeannt in NewClassification von Classifikation.h                                       */
/* -                                                                                                            */
/* -                                                                                                            */
/* -------------------------------------------------------------------------------------------------------------*/

#ifndef NEWCLASSIFICATION_H
#define NEWCLASSIFICATION_H


#include "TermOperationen.h"
#include "general.h"
#include "RUndEVerwaltung.h"
#include "InfoStrings.h"
#include "SUEBasis.h"

#ifdef __cplusplus
extern "C" {
#endif

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Initialize ------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void C_ParamInfo(ParamInfoArtT what, int whichModule, 
                 InfoStringT clasDEF, InfoStringT clasUSR, 
                 InfoStringT reclasDEF, InfoStringT reclasUSR, 
                 InfoStringT cgDEF, InfoStringT cgUSR);
/* whichModule: 1 - CLAS
                2 - RECLAS
                3 - CGCLAS
*/

BOOLEAN C_InitAposteriori(InfoStringT clasDEF, InfoStringT clasUSR, 
                          InfoStringT reclasDEF, InfoStringT reclasUSR, 
                          InfoStringT cgDEF, InfoStringT cgUSR);

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Classify --------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/
typedef WeightT (* ClassifyProcT) (TermT, /* lhs */
				   TermT, /* rhs */
				   RegelOderGleichungsT, /* actualParent */
				   RegelOderGleichungsT, /* otherParent */
				   UTermT, /* actualPosition */
				   BOOLEAN); /* TRUE: is CP, FALSE: is CG */

void
C_Classify (WeightEntryT *wtPtr, TermT lhs, TermT rhs,
	    RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent,
	    UTermT actualPosition,
	    CPHistoryT History);

void C_ReClassify (WeightEntryT *wtPtr, TermT lhs, TermT rhs,
		   RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent);
        
void
C_CG_Classify (WeightEntryT *wtPtr, TermT lhs, TermT rhs,
	       RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent);


/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Statistics ------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/


void C_Statistics(InfoStringT IS);

extern void (* C_WeightStatisticsStartProc) (InfoStringT);
extern void (* C_WeightStatisticsEndProc) (void);
extern PQ_WatchingWalkthroughProcedureT C_WeightStatProc;

#define C_WeightStatisticsStart(StatisticsIS) ((* C_WeightStatisticsStartProc) (StatisticsIS))
#define C_WeightStatisticsEnd() ((* C_WeightStatisticsEndProc) ())


/* -------------------------------------------------------------------------------------------------------------*/
/* ------------ CLEANING WOMAN ---------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void C_CleanUp(void);

#ifdef __cplusplus
}
#endif

#endif

