/**********************************************************************
* Filename : Ordnungen.h
*
* Kurzbeschreibung : Ordnungen
*                    Generieren von Ordnungen fuer Beispiele
*
* Autoren : Andreas Jaeger
*
* 14.12.96: Erstellung
*
*
* Benoetigt folgende Module:
*
* Benutzte Globale Variablen aus anderen Modulen:
*
**********************************************************************/
#ifndef ORDNUNGEN_H
#define ORDNUNGEN_H

#include "compiler-extra.h"
#include "general.h"
#include "InfoStrings.h"
#include "TermOperationen.h"

#ifdef __cplusplus
extern "C" {
#endif

/* ORD-1 */
/*-------*/

VergleichsT ORD_VergleicheTerme(UTermT term1, UTermT term2);
/* Vergleicht die beiden angegebenen Terme nach der eingestellten Ordnung. */


/* ORD-1a*/
/*-------*/
/* Die beiden folgenden Funktionen unterscheiden sich lediglich in der verwendeten Zeitmessung
   (unterschiedliche Zaehler).*/

BOOLEAN ORD_TermGroesserRed(UTermT term1, UTermT term2);
/* Testet, ob term1 groesser als term2 ist (bzgl. der eingestellten Ordnung). */

BOOLEAN ORD_TermGroesserUnif(UTermT term1, UTermT term2);
/* Testet, ob term1 groesser als term2 ist (bzgl. der eingestellten Ordnung). */


void ORD_ParamInfo(ParamInfoArtT what, InfoStringT DEF, InfoStringT USR);

BOOLEAN ORD_InitAposteriori (InfoStringT DEF, InfoStringT USR);

void ORD_OrdnungUmstellen(ordering Ordnung);


#ifdef __cplusplus
}
#endif

#endif /* ORDNUNGEN_H */
