/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Immergleiche Statistik-Variablen und Funktionen -----------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/
#ifndef PQSTATISTIK_H
#define PQSTATISTIK_H

#include "general.h"
#include "InfoStrings.h"

#ifdef __cplusplus
extern "C" {
#endif

#define PQ_STATISTIK normal_power_comp(1,0,0)
  

void PQStatistik(InfoStringT IS, long int AnzGueltigeKPsInMenge);

#if PQ_STATISTIK
extern CounterT        AnzKPSpaeterWaisenmord;            /* Bei erreichen der Top-Position der PQ als Waisen gekillte KPs */
extern CounterT        AnzKPFrueherWaisenmord;            /* Vorzeitig als Waisen gekillte KPs */

extern CounterT        AnzKPIRBetrachtet;                 /* Bei der KPM-IR insgesamt betrachtete KPs */
extern CounterT        AnzKPIRWaisenmord;                 /* Bei der KPM-IR als Waisen geloeschte KPs */
extern CounterT        AnzKPIRGeloescht;                  /* Bei der KPM-IR von der Anwendungsprozedur geloeschte KPs */
extern CounterT        AnzKPIRVeraendert;                 /* Bei der KPM-IR reduzierte und deshalb ggf. verschobene KPs */
extern CounterT        AnzKPIRVorgezogen;                 /* Bei der KPM-IR red. und gewichtsverkleinerte KPs */
extern CounterT        AnzKPIRZurueckgeschoben;           /* Bei der KPM-IR red. und gewichtsvergroesserte KPs */

extern CounterT        AnzKPBlaeh;                        /* Maximal gleichzeitig gespeicherte KP's */
extern CounterT        AnzKPEingefuegt;                   /* Anzahl der insgesamt eingefuegten KPs */
extern CounterT        AnzKPGeloescht;                    /* Anzahl der insgesamt (incl. Waisenmord) entfernten KPs */

#define IncAnzKPSpaeterWaisenmord() (AnzKPSpaeterWaisenmord++)
#define IncAnzKPFrueherWaisenmord() (AnzKPFrueherWaisenmord++)

#define IncAnzKPIRBetrachtet() (AnzKPIRBetrachtet++)
#define IncAnzKPIRWaisenmord() (AnzKPIRWaisenmord++)
#define IncAnzKPIRGeloescht() (AnzKPIRGeloescht++)
#define IncAnzKPIRVeraendert() (AnzKPIRVeraendert++)
#define IncAnzKPIRVorgezogen() (AnzKPIRVorgezogen++)
#define IncAnzKPIRZurueckgeschoben() (AnzKPIRZurueckgeschoben++)

#define IncAnzKPEingefuegt()(AnzKPEingefuegt++,AnzKPBlaeh =((AnzKPEingefuegt-AnzKPGeloescht)>AnzKPBlaeh)?(AnzKPEingefuegt-AnzKPGeloescht):AnzKPBlaeh)
#define IncAnzKPEntfernt()   (AnzKPGeloescht++)

#define IncAnzInitialerKPs(condition, ToIncrement) (ToIncrement += condition? 1:0)

#else


#define IncAnzKPSpaeterWaisenmord()                     /* Nix Tun */
#define IncAnzKPFrueherWaisenmord()                     /* Nix Tun */

#define IncAnzKPIRBetrachtet()                          /* Nix Tun */
#define IncAnzKPIRWaisenmord()                          /* Nix Tun */
#define IncAnzKPIRGeloescht()                           /* Nix Tun */
#define IncAnzKPIRVeraendert()                          /* Nix Tun */
#define IncAnzKPIRVorgezogen()                          /* Nix Tun */
#define IncAnzKPIRZurueckgeschoben()                    /* Nix Tun */

#define IncAnzKPEingefuegt()                            /* Nix Tun */
#define IncAnzKPEntfernt()                              /* Nix Tun */

#define IncAnzInitialerKPs(condition, ToIncrement)      /* Nix Tun */

#endif /* PQ_STATISTIK */

#ifdef __cplusplus
}
#endif

#endif
