#ifndef SUE_BASIS_H
#define SUE_BASIS_H


#include "TermOperationen.h"
#include "RUndEVerwaltung.h"

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Typedefs --------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif


typedef struct{
  WeightT w1, w2;
} WeightEntryT;

typedef void * TermpairT;

typedef void *PQInfoBlockT;


typedef int (* PQ_WalkthroughProcedureT) (TermT, TermT, RegelOderGleichungsT Father, RegelOderGleichungsT Mother, PCL_ObjektNummerT *);
/* 
   returns: 0 -- noop
            1 -- delete
            2 -- reweight
 */

typedef void (* PQ_WatchingWalkthroughProcedureT)(WeightEntryT, TermpairT, RegelOderGleichungsT, RegelOderGleichungsT);
/* Zum 'beobachtenden' Durchlaufen der KP-Menge. 
*/

/* Reihenfolge der Werte nicht aendern - wird in NewClassification benoetigt */
typedef enum{CPWithFather, CPWithMother, Initial, KilledRE, ChaseManhattanCP, TWreceived, CPHistory_Last
} CPHistoryT;


/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Variablen -------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

extern struct GNTermpaarTS SUE_Demigod;

#define IsDemigod(re)  (re == &SUE_Demigod)

extern TermT SUE_ReplicationOfLHS, SUE_ReplicationOfRHS;

extern RegelOderGleichungsT SUE_ActualParent;

/* letztes Selektiertes CP/CG wurde mit Strategie Fifo selektiert */
extern BOOLEAN SUE_LastSelectedWasFifo;


/* Generated CPs */
/* ------------- */
extern CPHistoryT           SUE_recCPGenerationHistory;
extern TermT                SUE_recCPrhs, SUE_recCPlhs;
extern PCL_ObjektNummerT    SUE_recCPpclID;
extern UTermT               SUE_recCPactualPosition;
extern TermpairT            SUE_recCPTermpair;
extern RegelOderGleichungsT SUE_recCPOtherParent;

/* Selected CPs */
/* ------------ */

extern TermT                SUE_selCPlhs, SUE_selCPrhs;
extern RegelOderGleichungsT SUE_selCPactualParent, SUE_selCPotherParent;
extern PCL_ObjektNummerT    SUE_selCPpclID;
extern TermpairT            SUE_selCPTermpair;

/* Touched CPs */
/* ----------- */
/* Daten werden nicht globalisiert, sondern bleiben auf den Aufruf der Anwendungsprozedur beschraenkt!*/



#ifdef __cplusplus
}
#endif

#endif /* SUE_BASIS_H */
