/**********************************************************************
* Filename : SelectClassify.h
*
* Kurzbeschreibung : Behandlung von Regel/Gleichungspaaren, die
*                    MNF bei Select erzeugt
*
* Autoren : Andreas Jaeger
*
* 05.09.96: Erstellung
*
**********************************************************************/

#ifndef SELECTCLASSIFY_H
#define SELECTCLASSIFY_H

#include "general.h"
#include "InfoStrings.h"
#include "TermOperationen.h"
#include "MNF_CPs.h"

#ifdef __cplusplus
extern "C" {
#endif


typedef enum {SC_Left, SC_Right} SC_SideT;

typedef struct SC_REPairsTS {
   struct SC_REPairsTS      *next;
   TermT                    left;
   TermT                    right;
   VergleichsT              vergleich;
   int                      weightP;
   BOOLEAN                  VerbindetLR;
   BOOLEAN                  keep;   /* intern: Behalten? */
} SC_REPairsT, *SC_REPairsPtrT;


BOOLEAN SC_InitAposteriori (InfoStringT DEF, InfoStringT USR,
                            unsigned short PermGrad_R, unsigned short PermGrad_E, 
                            BOOLEAN Subsumption);

void SC_ParamInfo (ParamInfoArtT what, InfoStringT DEF, InfoStringT USR);

void SC_Statistik (InfoStringT IS);

void SC_DeletePairs (SC_REPairsT **REPairs);

void SC_DeletePairsTermLoeschen (SC_REPairsT **REPairs);


/* Classifizieren der Regeln/Gleichungen */
void SC_Classify (MNF_NFSetT *NFLeft, MNF_NFSetT *NFRight, SC_REPairsT **REPairs);



#ifdef __cplusplus
}
#endif

#endif /* SELECTCLASSIFY_H */
