/* ----------------------------------------------------------------------------------------------------------
   Statistiken.h
  
   Diese Modul ist zustaendig fuer die Ausgabe von Statistiken, genauer:

   Fuer den Aufruf der Statistik-Funktionen der einzelnen Module,
   fuer Ergebnis-Ausgabe, und fuer Ergebnis- und Zwischen-Menues.

   20.06.96 Ausgelagert aus Ausgaben

*/
#ifndef STATISTIKEN_H
#define STATISTIKEN_H


#include "InfoStrings.h"
#include "general.h"

#ifdef __cplusplus
extern "C" {
#endif

/* -------------------------------------------------------*/
/* -------------- Initialisierung ------------------------*/
/* -------------------------------------------------------*/

void ST_InitAposteriori(InfoStringT KeDEF, InfoStringT KeUSR);

/* -------------------------------------------------------*/
/* -------------- Statistik ------------------------------*/
/* -------------------------------------------------------*/
/* Bei eingeschalteter Interaktion: Interaktives Ergebnis-Menue.
   Sonst Ausgabe diverser Daten gemaess Aufruf.

   In den Modi convergence und termination, wo der Terminationstest auf der Regelmenge ausgefuehrt wird,
   gibt der Wert von Resultat an, ob alle Ausgangsgleichungen richtbar waren.
*/

void ST_SuccessStatistik(const char *Bemerkung, BOOLEAN Resultat);
void ST_ErrorStatistik(const char *Bemerkung, BOOLEAN Resultat);
void ST_NoMemory (const char *Bemerkung, BOOLEAN Resultat);
void ST_TimeoutStatistik(const char *Bemerkung, BOOLEAN Resultat);
void ST_SignalUsrStatistik(const char *Bemerkung);
void ST_GoalProvedStatistik(const char *Bemerkung);
#if COMP_POWER
void ST_PowerStatistik(const char *Bemerkung);
#endif

/* -------------------------------------------------------*/
/* -------------- Interne Statistik ----------------------*/
/* -------------------------------------------------------*/

void ST_InterneStatistik(void);
/* Ausgabe von internen Daten (zB. Pfad-Ausdehnungen etc.) */

/* -------------------------------------------------------*/
/* -------------- Prozess-Statistik ----------------------*/
/* -------------------------------------------------------*/

void ST_ProzessStatistik(void);
/* Ausgabe von Prozess-Daten (aus getrusage)  */

/* -------------------------------------------------------*/
/* -------------- Konfiguration --------------------------*/
/* -------------------------------------------------------*/

void ST_DruckeKonfiguration(void);

/* -------------------------------------------------------*/
/* -------------- Ergebnis-Menue -------------------------*/
/* -------------------------------------------------------*/

void ST_IRMenue(const char *where);
/* Menuegesteuerte Ausgabe von Statistiken und Ergebnissen, Mengen
   sowie Anstossen der KPM-IR.
*/

#ifdef __cplusplus
}
#endif

#endif
