/*=================================================================================================================
  =                                                                                                               =
  =  YFiles.c                                                                                                     =
  =                                                                                                               =
  =  Kapselung der Zeichenketten fuer kommandozeilenartige Parametereinstellungen                                 =
  =                                                                                                               =
  =  18.08.98 Aus PhilMarlow.c extrahiert. Thomas.                                                                =
  =                                                                                                               =
  =================================================================================================================*/

#include "PhilMarlow.h"
#include "XFiles.h"
#include "YFiles.h"
#include "SpeicherVerwaltung.h"
#include "compiler-extra.h"

void empty(void) {;}


void lpo_(PraezedenzartenT Art, Signatur_SymbolT sig, Signatur_ZeichenT sig_c)
{
  char *Praezedenz = PG_Praezedenz(Art,sig,sig_c,ordering_lpo);
  oprintf("-ord lpo:prec=%s",Praezedenz);
  our_dealloc(Praezedenz);
}


void kbo_(PraezedenzartenT Art, Signatur_SymbolT sig, Signatur_ZeichenT sig_c)
{
  char *Praezedenz = PG_Praezedenz(Art,sig,sig_c,ordering_kbo);
  oprintf("-ord kbo:DEF=1:prec=%s",Praezedenz);
  our_dealloc(Praezedenz);
}


void nao(PraezedenzartenT Art MAYBE_UNUSEDPARAM)
{
  oprintf("-ord col4");
}


void zb(ZielbehandlungsartenT Art)
{
  const char *Parametrisierungen[] = 
  { "rnf",
    "mnf=re.0:s:mnfanalysis=100.200.4:mnfantiWOVar:mnfantir=5:mnfup=5",
    "mnf=re.0:s:mnfanalysis=1000.2000.10:mnfantiWOVar:mnfantir=5:mnfup=5"
  };
  oprintf("-zb %s",Parametrisierungen[Art]);
}


static void KlassifikationDrucken(HeuristikartenT Art, char *ClasPraefix)
{
  const char *Parametrisierungen[] = { "addweight", "Addweight", "mixweight", "gtweight", "Mixweight", "polyweight" };
  oprintf("-%sclas heuristic=%s",ClasPraefix,Parametrisierungen[Art]);
}

void cph(HeuristikartenT Art)
{
  KlassifikationDrucken(Art,"");
}

void cgh(HeuristikartenT Art)
{
  KlassifikationDrucken(Art,"cg");
}


void itl(VerschnittT Verschnitt)
{
  const struct {
    unsigned int Fifo,
                 Heuristik;
  } Schrittweiten[] = {{1,200},{1,100},{1,50},{5,100},{1,10}},
  Schrittweite = Schrittweiten[Verschnitt];
  oprintf("-pq interleave=%d.%d",Schrittweite.Fifo,Schrittweite.Heuristik);
}


void einsstern(void)
{
  oprintf("-einsstern");
}

void cgcp(void)
{
  oprintf("-sue cgcp=1.10");
}


void back(void)
{
  oprintf("-back");
}


void rose(void)
{
  if (!PM_Existenzziele) {
    oprintf("-zb mnf=re.0:s:mnfanalysis=1000.2000.10:mnfantiWOVar:mnfantir=5:mnfup=5");
    oprintf("-ord col3 -kg -: -ks -:@");
  }
}


void kern(void)
{
  oprintf("-kg -:s -ks -:s -kern");
  NeueStrategie(0);                                           /* Dummy fuer eventuelle Modifikation durch Konsulat */
}


void bis(SchrittzahlT Selektor)
{
  const unsigned int Schrittzahlen[] = {700,6500,14000},
                     Schrittzahl = Schrittzahlen[Selektor];
  test_error(!Schrittzahl, "Strategie fuer 0 Schritte angegeben in Tafel2");
  NeueStrategie(Schrittzahl);
}
