/*=================================================================================================================
  =                                                                                                               =
  =  ManagerMemorium.c                                                                                            =
  =                                                                                                               =
  =  Plattform fuer SpeicherManager auf mmap-Basis                                                                =
  =                                                                                                               =
  =  19.02.97 Thomas.                                                                                             =
  =                                                                                                               =
  =================================================================================================================*/

#include "general.h"
#include "ManagerMemorium.h"
#include "FehlerBehandlung.h"


/*=================================================================================================================*/
/*= I. Managerdomaenen                                                                                            =*/
/*=================================================================================================================*/

static void ManagerHaken(void *Kollision)
{
  DomaenenT Domaene = *((DomaenenT*)Kollision-1);
  SV_SpeicherManagerT *Manager = *((SV_SpeicherManagerT**)Kollision-3);
  if (Manager->mbl_size>DM_Seitengroesse()) {          /* sonst keine Luecke gelassen worden -> nichts nachzuholen */
    char *Blockende = (char*)Kollision+Manager->mbl_size-DM_Seitengroesse();
    if (ptr2ul(Blockende)>ptr2ul(Domaene->Obergrenze))
      our_error("Domaene waechst ueber vorgesehenen Adressraum.");
    DM_mmap(Kollision,Blockende);
  }
  SV_Blockdurchzeigerung(Manager,(char*)Kollision-DM_Seitengroesse(),
    (char*)Domaene->Ende+sizeof(struct mem_block_list *));  

  DM_AmEndeGesperrtAllokieren(Domaene,DM_Seitengroesse(),Manager);
#ifdef SV_BASIS_MMAP  
  if_sst(
    Manager->Sperre_next_free = 
      (StichAdressT) ((char*)Domaene->Ende-DM_Seitengroesse()+sizeof(struct mem_block_list *)));
#endif
  Domaene->Ende = (char*)Domaene->Ende + (unsigned long int)(Manager->mbl_size - DM_Seitengroesse());
  if_sst(
    Domaene->AnzahlDomaenenausdehnungen++;  
    Domaene->AnzahlGemapptePages += Manager->mbl_size/DM_Seitengroesse();
    MaximierenLong(&Domaene->AnzahlMaxGemapptePages,Domaene->AnzahlGemapptePages-Domaene->AnzahlGeunmapptePages));
}


DomaenenT MM_NeueManagerdomaene(DomaenenbereichsT Bereich, const char *Name)
{
  return DM_NeueDomaene(Managerdomaene,Bereich,ManagerHaken,Name);
}


void MM_ManagerdomaeneLeeren(volatile DomaenenT Domaene, SV_SpeicherManagerT *ManagerListe)
{
  DM_DomaeneLeeren(Domaene);
  while (ManagerListe) {
    MM_InitManager(ManagerListe,Domaene);
    ManagerListe = ManagerListe->Nachf;
  }
}


void MM_ManagerdomaeneLoeschen(volatile DomaenenT Domaene)
{
  DM_DomaeneLoeschen(Domaene);
}



/*=================================================================================================================*/
/*= II. Manager einsetzen                                                                                         =*/
/*=================================================================================================================*/

void MM_InitManager(SV_SpeicherManagerT *Manager, volatile DomaenenT Domaene)
{
  DM_AmEndeGesperrtAllokieren(Domaene,DM_Seitengroesse(),Manager);
  Manager->next_free = (StichAdressT)((char*)Domaene->Ende-DM_Seitengroesse()+sizeof(struct mem_block_list *));
#ifdef SV_BASIS_MMAP  
  if_sst(Manager->Sperre_next_free = Manager->next_free);
#endif
  Domaene->Ende = (char*)Domaene->Ende + (unsigned long int)(Manager->mbl_size - DM_Seitengroesse());
  if_sst(
    Domaene->AnzahlDomaenenausdehnungen++;  
    Domaene->AnzahlGemapptePages++;
    MaximierenLong(&Domaene->AnzahlMaxGemapptePages,Domaene->AnzahlGemapptePages-Domaene->AnzahlGeunmapptePages));
}
