/**********************************************************************
* Filename : ClasPatch
*
* Kurzbeschreibung : Classificationsheuristiken - Spielwiese
*                    
* Autoren : Andreas Jaeger,...
*
* 25.03.98: Erstellung
* 
*
*
**********************************************************************/


#include <stdlib.h>
#include <string.h>
#include "compiler-extra.h"
#include <limits.h>

#include "Ausgaben.h"
#include "ClasFunctions.h"
#include "ClasHeuristics.h"
#include "ClasPatch.h"
#include "Ordnungen.h"
#include "SymbolGewichte.h"
#include "SymbolOperationen.h"
#include "TermOperationen.h"
#include "Unifikation1.h"
#include "general.h"
#include "DSBaumOperationen.h"

/* Classifikationsroutinen haben alle folgende Aufrufsyntax:
   wtPtr: WeightEntryT
   lhs: TermT
   rhs: TermT
   actualParent: RegelOderGleichungsT
   otherParent: RegelOderGleichungsT
   actualPosition: UTermT : Position in actualParent?
Wo?-> CG/CP
   type ist ClassifyProcT
(WeightEntryT *wtPtr, TermT lhs, TermT rhs, RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent, UTermT actualPosition);
*/

static int CPvariante = 0;
static int CGvariante = 0;



void CPA_CPInit (int no)
{
  CPvariante = no;
  fprintf (IO_Strom, "  Spielwiese fuer CPs: Variante %d initialisiert.\n", no);
}


void CPA_CGInit (int no)
{
  CGvariante = no;
  fprintf (IO_Strom, "  Spielwiese fuer CGs: Variante %d initialisiert.\n", no);
}



WeightT CPA_CPPatch (TermT lhs MAYBE_UNUSEDPARAM, 
		     TermT rhs MAYBE_UNUSEDPARAM,
		     RegelOderGleichungsT actualParent MAYBE_UNUSEDPARAM,
		     RegelOderGleichungsT otherParent MAYBE_UNUSEDPARAM ,
		     UTermT actualPosition MAYBE_UNUSEDPARAM,
		     BOOLEAN isCP MAYBE_UNUSEDPARAM)
{
  switch (CPvariante)
    {
      /* bitte die Nummern nicht aendern, sondern neue Vergeben */
    default:
      our_error ("Nicht implementiert!");
      break;
    }
  
  return 1;
}


WeightT CPA_CGPatch (TermT lhs MAYBE_UNUSEDPARAM, 
		     TermT rhs MAYBE_UNUSEDPARAM,
		     RegelOderGleichungsT actualParent MAYBE_UNUSEDPARAM,
		     RegelOderGleichungsT otherParent MAYBE_UNUSEDPARAM ,
		     UTermT actualPosition MAYBE_UNUSEDPARAM,
		     BOOLEAN isCP MAYBE_UNUSEDPARAM)
{
  switch (CGvariante)
    {
    default:
      our_error ("Nicht implementiert!");
      break;
    }
  
  return 1;
}
