/**********************************************************************
* Filename : ZielAusgaben.h
*
* Kurzbeschreibung : Ausgaben Zielverwaltung
*
* Autoren : Andreas Jaeger
*
* 04.02.99: Erstellung aus Ausgaben.h heraus
**********************************************************************/

#include "Ausgaben.h"
#include "compiler-extra.h"
#include "general.h"
#include <stdio.h>
#include "ZielAusgaben.h"


static void ZielBewiesenDrucken (void)
{
   fprintf(IO_Strom,  "\n" );
   fprintf(IO_Strom,  "        +--------------------------+\n" );
   fprintf(IO_Strom,  "        |   this proves the goal   |\n" );
   fprintf(IO_Strom,  "        +--------------------------+\n\n" );
}


void ZA_ZielReduziertDrucken (unsigned int Nummer MAYBE_UNUSEDPARAM, TermT links MAYBE_UNUSEDPARAM, TermT rechts MAYBE_UNUSEDPARAM)
{
#if IO_AUSGABEN  
  if (IO_level4)
    IO_DruckeFlex("goal no. %u simplified: %t =? %t\n\n", Nummer, links, rechts);
  else if (IO_level2) {
    fprintf(IO_Strom, "simplify goal:   %7u  ", Nummer);
    IO_DruckeFlex("%t =? %t\n", links, rechts);
  }
  else
    fprintf(IO_Strom, "Goal no. %u simplified\n\n", Nummer);
#else
  ;
#endif
}


void ZA_ZielZusammengefuehrtDrucken (void) 
{
#if IO_AUSGABEN  
  if (IO_level2)
    ZielBewiesenDrucken ();
  else
    fprintf(IO_Strom, "... and hence joined\n\n");
#else
  fprintf (IO_Strom, "goal joined\n");
#endif
}

  
void ZA_ZielSubsummiertDrucken (unsigned int ZielNummer, long int GleichungsNummer,
                                TermT Zlinks MAYBE_UNUSEDPARAM, TermT Zrechts MAYBE_UNUSEDPARAM,
                                TermT Glinks MAYBE_UNUSEDPARAM, TermT Grechts MAYBE_UNUSEDPARAM)
{
#if IO_AUSGABEN
  if (IO_level4) {
    fprintf(IO_Strom, "goal no. %u subsumed by equation no. %ld\n", ZielNummer, -GleichungsNummer);
    IO_DruckeFlex("  (%t = %t subsumes %t ?= %t)\n\n", Glinks, Grechts, Zlinks, Zrechts);
  }
  else if (IO_level2) {
    fprintf(IO_Strom, "goal holds true because:       %4ld  ", -GleichungsNummer);
    IO_DruckeFlex("%t = %t\n", Glinks, Grechts);
    ZielBewiesenDrucken ();
  }
  else
    fprintf(IO_Strom, "goal no. %u subsumed by equation no. %ld\n\n", ZielNummer, -GleichungsNummer);

#else
  fprintf(IO_Strom, "goal no. %u subsumed by equation no. %ld\n\n", ZielNummer, GleichungsNummer);
#endif
}
