#include "parse-util.h"
#include <malloc.h>
#include <string.h>

extern void yyerror(char *);

char *error_msg = NULL;
static size_t error_msg_len;

static P_Symbol_T *Symbole;
static int next_symbol = 0;

/* Returns:
   0 - if symbol already defined with different arity
   !=0 - if everything is ok
*/
int check_symbol (char *name, int no_args)
{
  int i;
#if 0  
  printf ("check_symbol: %s - %d\n", name, no_args);
#endif
  for (i = 0; i < next_symbol; i++)
    {
      if (strcmp (Symbole[i].name, name) == 0)
	{
	  if (Symbole[i].no_args != no_args)
	    {
	      if (error_msg == NULL)
		{
                   /* 60 = 38 + 10 + 10 fuer sprintf aufruf.
                      An sich wuerde ich lieber snprintf benutzen,
                      aber die Funktion fehlt unter Solaris 2.5.
                    */
		  error_msg_len = strlen(name) + 60;
		  error_msg = malloc (error_msg_len);
		}
              if (strlen(name)+60 > error_msg_len)
                 {
                    error_msg_len += strlen(name) + 60;
                    error_msg = realloc (error_msg, error_msg_len);
                 }
              sprintf (error_msg,
                       "`%s' had previously %d args but now %d args!",
                       name, Symbole[i].no_args, no_args);
              /* Fehler  */
              return 0;
	    }
          /* Ansonsten alles klar.  */
	  return 1;
	}
    }
  if (next_symbol == 0)
    Symbole = malloc (sizeof(P_Symbol_T));
  else
    Symbole = realloc (Symbole, sizeof(P_Symbol_T) * (next_symbol+1));
  Symbole[next_symbol].name = strdup (name);
  Symbole[next_symbol].no_args = no_args;
  Symbole[next_symbol].is_var = 0;
  next_symbol++;

  return 1;
}

void print_symbols (void)
{
  int i;

#if 0
  printf ("List of all symbols:\n");
#endif
  for (i = 0; i < next_symbol; i++)
    {
      printf ("%s<=>%d\n", Symbole[i].name, Symbole[i].no_args);
    }
}
