%{
#include "parse-util.h"

%}

%union{
   char     *ident;
   int      test;
   P_Term_T term;
   P_Term_T term_list;
   void *   equation;
}

%token EQ
%token <ident> SYMB
%token <equation> ENDOFLINE
%token <ident> OP
%nonassoc OP

%type <term_list> termlist
%type <term> term
%type <equation> equation
%type <equation> equationlist

%start equationlist
%%

equationlist:
        equation
    |   equationlist equation
    ;

equation:
        term EQ term ENDOFLINE {$$;}
    |   ENDOFLINE
    ;

term:
    	SYMB '(' termlist ')'  
	  { $$.no_args=$3.no_args;
	    if (!check_symbol ($1, $$.no_args)) {
	      yyerror(error_msg);
	      YYERROR;
            }
          }
    |   OP '(' termlist ')'  
	  { $$.no_args=$3.no_args;
	    if (!check_symbol ($1, $$.no_args)) {
	      yyerror(error_msg);
	      YYERROR;
            }
          }
    |   term OP term
	  { $$.no_args=2;
	    if (!check_symbol ($2, $$.no_args)) {
	      yyerror(error_msg);
	      YYERROR;
            }
          }
    |   SYMB '(' ')'  
	  { $$.no_args=0;
	    if (!check_symbol ($1, $$.no_args)) {
	      yyerror(error_msg);
	      YYERROR;
            }
	  }
    |   SYMB 
	  { $$.no_args = 0;
	    if (!check_symbol ($1, $$.no_args)) {
	      yyerror(error_msg);
	      YYERROR;
            }
	  }
     |  '(' term ')'
          {$$ = $2;}
    ;


termlist:
    	termlist ',' term 
	  { $1.no_args++; $$=$1;}
    |   term
	  { $$.no_args=1;}
    ;
