#include "compiler-extra.h"
#include "Ausgaben.h"
#include "PQStatistik.h"
#include "InfoStrings.h"

/* ------------------------------------------------------------------------*/
/* ---------- globale Variablen (siehe PQStatistik.h) ---------------------*/
/* ------------------------------------------------------------------------*/

#if PQ_STATISTIK
CounterT        AnzKPSpaeterWaisenmord;            /* Bei erreichen der Top-Position der PQ als Waisen gekillte KPs */
CounterT        AnzKPFrueherWaisenmord;            /* Vorzeitig als Waisen gekillte KPs */

CounterT        AnzKPIRBetrachtet;                 /* Bei der KPM-IR insgesamt betrachtete KPs */
CounterT        AnzKPIRWaisenmord;                 /* Bei der KPM-IR als Waisen geloeschte KPs */
CounterT        AnzKPIRGeloescht;                  /* Bei der KPM-IR von der Anwendungsprozedur geloeschte KPs */
CounterT        AnzKPIRVeraendert;                 /* Bei der KPM-IR reduzierte und deshalb ggf. verschobene KPs */
CounterT        AnzKPIRVorgezogen;                 /* Bei der KPM-IR red. und gewichtsverkleinerte KPs */
CounterT        AnzKPIRZurueckgeschoben;           /* Bei der KPM-IR red. und gewichtsvergroesserte KPs */

CounterT        AnzKPBlaeh;                        /* Maximal gleichzeitig gespeicherte KP's */
CounterT        AnzKPEingefuegt;                   /* Anzahl der insgesamt eingefuegten KPs */
CounterT        AnzKPGeloescht;                    /* Anzahl der insgesamt (incl. Waisenmord) entfernten KPs */
#endif

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Immergleiche Statistik-Variablen und Funktionen -----------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/


void PQStatistik(InfoStringT IS MAYBE_UNUSEDPARAM, long int AnzGueltigeKPsInMenge MAYBE_UNUSEDPARAM)
{
#if PQ_STATISTIK
   if (IS_IsIn("latex-head", IS))
      fprintf(IO_Strom, "$>$PQ & $<$PQ & frWM & spWM & in PQ: act & alive & max &KPIR: angef. & beh. & WM & gel & geaend. & vorg. & zur. & ");
   else{
      int tiefe1, tiefe2, tiefe3;
      
      IO_DruckeStatistikZeile("ues inserted into PQ", AnzKPEingefuegt);
      IO_DruckeStatistikZeile("ues removed from PQ", AnzKPGeloescht);
      IO_DruckeStatistikZeileEingerueckt("of them because of early orphan murder", AnzKPFrueherWaisenmord, 
                                         IO_Einruecktiefe(0, Maximum(2, AnzKPFrueherWaisenmord, AnzKPSpaeterWaisenmord)));
      IO_DruckeStatistikZeileEingerueckt("of them because of late orphan murder", AnzKPSpaeterWaisenmord, 
                                         IO_Einruecktiefe(0, Maximum(2, AnzKPFrueherWaisenmord, AnzKPSpaeterWaisenmord)));
      IO_DruckeStatistikLeerZeile();
      IO_DruckeStatistikZeile("ues currently in PQ", AnzKPEingefuegt - AnzKPGeloescht);
      IO_DruckeStatistikZeileEingerueckt("of them still valid", AnzGueltigeKPsInMenge, IO_Einruecktiefe(0, AnzGueltigeKPsInMenge));
      IO_DruckeStatistikLeerZeile();
      IO_DruckeStatistikZeile("Max. No. of ues in PQ", AnzKPBlaeh);
      
      IO_DruckeStatistikLeerZeile();
      IO_DruckeStatistikZeile("ues touched during IRP", AnzKPIRBetrachtet);
      tiefe1 = IO_Einruecktiefe(0, Maximum(2, AnzKPIRWaisenmord, AnzKPIRBetrachtet-AnzKPIRWaisenmord));
      tiefe2 = IO_Einruecktiefe(tiefe1, Maximum(2, AnzKPIRGeloescht, AnzKPIRVeraendert));
      tiefe3 = IO_Einruecktiefe(tiefe2, Maximum(2, AnzKPIRVorgezogen, AnzKPIRZurueckgeschoben));
      
      IO_DruckeStatistikZeileEingerueckt("of them removed as orphans", AnzKPIRWaisenmord, tiefe1);
      IO_DruckeStatistikZeileEingerueckt("of them reprocessed", AnzKPIRBetrachtet-AnzKPIRWaisenmord, tiefe1);
      IO_DruckeStatistikZeileEingerueckt("of them removed", AnzKPIRGeloescht, tiefe2);
      IO_DruckeStatistikZeileEingerueckt("of them changed", AnzKPIRVeraendert, tiefe2);
      IO_DruckeStatistikZeileEingerueckt("of them prefered", AnzKPIRVorgezogen, tiefe3);
      IO_DruckeStatistikZeileEingerueckt("of them defered", AnzKPIRZurueckgeschoben, tiefe3);
   }
#else
   ;
#endif
}
