/*
Dieses Modul dient dem Initialisieren aller Strukturen nach dem Einlesen einer Spezifikation.

28.02.94 Angelegt.
03.03.94 Auf TermOperationen erweitert.

*/

/* -------------------------------------------------------*/
/* ------------- Includes --------------------------------*/
/* -------------------------------------------------------*/

#include "Ausgaben.h"
#include "DSBaumKnoten.h"
#include "DSBaumOperationen.h"
#include "DSBaumTest.h"
#include "DomaenenMemorium.h"
#include "FehlerBehandlung.h"
#include "Hauptkomponenten.h"
#include "Initialisierungen.h"
#include "Interreduktion.h"
#include "KBO.h"
#include "KPBildung.h"
#include "KPMengenInterreduktion.h"
#include "LispLists.h"
#include "LPOVortests.h"
#include "LispLists.h"
#include "MatchOperationen.h"
#include "NFBildung.h"
#include "Parameter.h"
#include "Praezedenzgenerator.h"
#include "Puffer.h"
#include "RUndEVerwaltung.h"
#include "SUEM.h"
#include "Subgleichungen.h"
#include "SymbolOperationen.h"
#include "TermOperationen.h"
#include "TermVerfolgung.h"
#include "Termpaare.h"
#include "Unifikation1.h"
#include "Unifikation2.h"
#include "VariablenMengen.h"
#include "ZeitMessung.h"
#include "Zielverwaltung.h"
#include "general.h"
#include "parser.h"
#include "pcl.h"

#include <stdlib.h>

/* -------------------------------------------------------*/
/* ------------- Funktionen ------------------------------*/
/* -------------------------------------------------------*/

void IN_SpezifikationEinlesen(char *filename)
/* Nur Spezifikation einlesen, damit extModus bekannt wird. */
{
#if !COMP_ACIDWM && !COMP_POWER
   fprintf(IO_Strom, "\nparsing %s", filename);
#endif
   parse_spec(filename);
#if !COMP_POWER
   fprintf(IO_Strom, "... done\n");
#endif
}
   

void IN_AllesAprioriInitialisieren(void)
/* Alles, was VOR Einlesen der Spezifikation passieren mu\3 oder kann. Die Aufrufparameter sind aber noch nicht eingestellt! */
{

   IO_InitApriori();  /* IO_Strom initialisieren */
   PA_InitApriori();  /* Parameter definieren */
   DM_InitApriori();  /* Signalbehandlung umbiegen fuer Domaenenverwaltung */
   SV_InitApriori();  /* Falls SV-Debug-Betrieb: Aufruf malloc_debug(2) */
   BK_InitApriori();  /* Speichermanager fuer innere und Blattknoten und Baumverwaltungseintraege */
   BO_InitApriori();  /* Variablenbank; Speichermanager fuer gerichtet normierte Termpaare */
   RE_InitApriori();  /* Variablenumbenennungsbank dynamisch erzeugen; NaechsteBaumvariable auf x1 setzen */
   MO_InitApriori();  /* Variablenbank fuer Matching dynamisch erzeugen */
   VM_InitApriori();  /* Speichermanager fuer Variablenmengen */
   U1_InitApriori();  /* Bindungsstack, Substitutions-Variablenbank, TermIteration */
   U2_InitApriori();  /* Bindungsstack, Substitutions-Variablenbank, TermIteration */
   TP_InitApriori();  /* Termpaar-Manager initialisieren. */
   TV_InitApriori();  /* Termiteration initialisieren. */
   BT_InitApriori();  /* Stapel in DSBaumTest initialisieren. */
   LL_InitApriori();  /* Listenzellenmanager einrichten */
}


void IN_SpezifikationGelesen(void)
/* Eingelesene Strukturen freigeben. */
{
   clear_spec();
}
