
#include "Ausgaben.h"
#include "Stringterms.h"
#include "Stringterms.h"
#include "SymbolOperationen.h"
#include "TermIteration.h"
#include "TermOperationen.h"
#include "general.h"

/* -------------------------------------------------------------------------------------------------------------*/
/* ------------------- Auslesen von Symbolen in gepackter Darstellung ------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/


static SymbolT Topsymbol(PTermpaarT *pp)
/* Liefert das Topsymbol von pp und schaltet den Zeiger pp um eine bzw. drei Stellen weiter.*/
{
   byte top = **pp;
   (*pp)++;
   if (top == -128){
      top = (long)(**pp) << 8;         (*pp)++;
      top = top | (long)(**pp);        (*pp)++;
   }
   return (SymbolT) top;
}
TI_IterationDeklarieren(STT)


/* -------------------------------------------------------------------------------------------*/
/* ------------------- Ein- und Auspacken von Termen -----------------------------------------*/
/* -------------------------------------------------------------------------------------------*/

static TermT TermAuspacken(PTermpaarT *pp)
/* Ersten Term aus Termpaar pp auspacken, dabei Rueckgabe-Term erzeugen.*/
{
  SymbolT Symbol = Topsymbol(pp);
#if 0
if (Symbol==20)
  printf("Jetzt eine gefaehrliche Stelle!\n");
#endif
  if (SO_Stelligkeit(Symbol)==0) {
    TermT TermNeu;
    TO_TermzelleHolen(TermNeu);
    TO_SymbolBesetzen(TermNeu,Symbol);
    TO_NachfBesetzen(TermNeu,NULL);
    TO_EndeBesetzen(TermNeu,TermNeu);
    return TermNeu;
  }
  else {
    TermT TermNeu = TO_HoleErsteNeueZelle(),
          IndexNeu = TermNeu;
    TO_SymbolBesetzen(TermNeu,Symbol);
    TI_Push(TermNeu);
    do {
      TO_AufNaechsteNeueZelle(IndexNeu);
      Symbol = Topsymbol(pp);
      TO_SymbolBesetzen(IndexNeu,Symbol);
      if (SO_Stelligkeit(Symbol)==0) {
        TO_EndeBesetzen(IndexNeu,IndexNeu);
        while (!(--TI_TopZaehler)) {
          TO_EndeBesetzen(TI_TopTeilterm,IndexNeu);
          if (TI_PopUndLeer()) {
            TO_LetzteNeueZelleMelden(IndexNeu);
            TO_NachfBesetzen(IndexNeu,NULL);
            return TermNeu;
          }
        }
      }
      else
        TI_Push(IndexNeu);
    } while (TRUE);
  }
}

#define ErhoehePlatzbedarf(pb,term)                                             \
{                                                                               \
   TermzellenZeigerT runny = term;                                              \
   do{                      /* Term durchlaufen, dabei Stellen zaehlen */       \
      pb++;                                                                     \
      if (TO_TermIstVar(runny) && (TO_TopSymbol(runny)<-127))                   \
        pb += 2;                                                                \
   }while ((runny = TO_Schwanz(runny)));                                        \
}

unsigned long int STT_TermpaarPlatzbedarf(TermT l, TermT r)
/* Termpaar durchlaufen und dabei tatsaechlichen Platzbedarf ermitteln:
   jede Variablen-Nummer < -127 wird mit drei Byte abgelegt!*/
{
   unsigned long int platzbedarf = 0;

   ErhoehePlatzbedarf(platzbedarf, l);
   ErhoehePlatzbedarf(platzbedarf, r);

   return platzbedarf;
}


void STT_TermpaarAuspacken(PTermpaarT *tp, TermT *lhsPtr, TermT *rhsPtr)
{
   *lhsPtr = TermAuspacken(tp);
   *rhsPtr = TermAuspacken(tp);
}

PTermpaarT STT_TermpaarEinpackenFragil(TermT lhs, TermT rhs, PTermpaarT tp)
/* Die Gleichung lhs=rhs in das uebergebene PTermpaar einschreiben. Bei Rueckgabe FALSE war 
   STT_TermpaarPlatzbedarf(lhs,rhs)>MaxSize. In diesem Falle neu aufrufen.
*/
{
   PTermpaarT pIndex;
   TermT tIndex;
   register long top;

   pIndex = tp;
   /* hier wird in das erste Byte des gepackte Termpaares die Nummer des */
   /* verwendeten Managers eingetragen */

   TO_NachfBesetzen(TO_TermEnde(lhs), rhs);
   tIndex = lhs;

   do{
      top = TO_TopSymbol(tIndex);
      if (top > -128){
         *pIndex = (byte) top;  pIndex++;
      }
      else{
        *pIndex = (byte) (-128);        pIndex++;
        *pIndex = (byte) ((top >> 8));  pIndex++;
        *pIndex = (byte) ((top & 0xff));  pIndex++;
     }
   }while((tIndex = TO_Schwanz(tIndex)));

   TO_NachfBesetzen(TO_TermEnde(lhs), NULL);
   return pIndex;
}

/* -------------------------------------------------------------------------------------------------------------*/
/* ------------------- Lexikographischer Vergleich gepackter Termpaare -----------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

BOOLEAN STT_TPTestSymbLex(PTermpaarT p1, PTermpaarT p2)
/* Liefert TRUE, wenn p1 im symbolweisen, lexikographischen Vergleich groesser ist als p2.*/
{
  unsigned long nochStellen1 = 2;
  SymbolT top1, top2;

/*  IO_DruckeFlex("Test von : %p ** %p liefert ", p1, p2);*/
  do{
    top1 = Topsymbol(&p1);
    top2 = Topsymbol(&p2);
    if (top1>top2) {/*fprintf(IO_Strom, "TRUE\n");*/return TRUE;}
    else if (top1<top2) {/*fprintf(IO_Strom, "FALSE\n");*/return FALSE;}
    nochStellen1 += SO_Stelligkeit(top1) - 1;
  }while (nochStellen1);
/*  fprintf(IO_Strom, "FALSE\n");*/
  return FALSE;                 /* Terme sind Gleich, wenn bis zum Ende von Termpaar1 keine Unterschiede aufgetreten sind. */
}


/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Output ----------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

byte *DurchlaufIndex;

static void DruckeTermAusPTermpaar(void)
/* Gepacktes Termpaar drucken.*/
{
  SymbolT symb;

  symb = Topsymbol(&DurchlaufIndex); /* schaltet weiter */
  if (SO_Stelligkeit(symb) == 0)
    IO_DruckeSymbol(symb);
  else
    do
      switch (SO_Stelligkeit(symb)) {
      case 0:
        {
          IO_DruckeSymbol(symb);
          while (!(--TI_TopZaehler)) {
            fprintf(IO_Strom, ")");
            if (TI_PopUndLeer())
              return;
          }
          fprintf(IO_Strom, ",");
          symb = Topsymbol(&DurchlaufIndex); /* schaltet weiter */
          break;
        }
      case 1:
        {
          SymbolT Symbol = Topsymbol(&DurchlaufIndex); /* schaltet weiter */
          unsigned int n = 1;
          while (SO_SymbGleich(symb, Symbol)) {
            n++;
            Symbol = Topsymbol(&DurchlaufIndex);
          }
          if (n>=StartzahlVerkettungskuerzung) {
            IO_DruckeSymbol(symb);
            fprintf(IO_Strom, "^%d(",n);
            TI_PushMitAnz(NULL,1); /* Stelligkeit war eins */
          }
          else
            while (n--) {
              IO_DruckeSymbol(symb);
              fprintf(IO_Strom, "(");
              TI_PushMitAnz(NULL,1);
            }
          symb = Symbol;
          break;
        }
      default:
        {
          IO_DruckeSymbol(symb);
          fprintf(IO_Strom, "(");
          TI_PushMitAnz(NULL,SO_Stelligkeit(symb)); /* mehrstellig -> Fkt-Symb */
          symb = Topsymbol(&DurchlaufIndex);
          break;
        }
      }
    while (TRUE);
}

void STT_DruckePTermpaar(byte *tp, const char *trenner)
{
  DurchlaufIndex = tp;
  DruckeTermAusPTermpaar();
  fprintf(IO_Strom, " %s ", trenner);
  DruckeTermAusPTermpaar();
}

static BOOLEAN STT_SchonInitialisiert = FALSE;

void STT_InitAposteriori(void)
{
  if (!STT_SchonInitialisiert)
    TI_IterationInitialisieren();
  STT_SchonInitialisiert = TRUE;
}

