/**********************************************************************
* Filename : ParseInterleave
*
* Kurzbeschreibung : Parsen von interleave-String
*
* Autoren : Andreas Jaeger
*
* 27.5.98: Erstellung
*
* Benoetigt folgende Module:
*
* Benutzte Globale Variablen aus anderen Modulen:
*   zur Zeit keine
*
**********************************************************************/

#include "general.h"
#include <string.h>
#include <stdlib.h>
#include "FehlerBehandlung.h"
#include "ParseInterleave.h"
#include "SpeicherVerwaltung.h"

BOOLEAN PI_ParseInterleave (const char *str, int *fifo, int *heuristic)
{
   char *kopie, *kopieDummy, *token;

   kopie = (char *) our_alloc (sizeof (char) * strlen (str));
   strcpy (kopie, str);
   kopieDummy = kopie;
   
  token = strtok (kopie, ":");
  while (token != NULL) {
    if (strncasecmp (token, "interleave=", strlen ("interleave=")) == 0) {
      token = strtok (token+strlen("interleave="), ".");
      *fifo = atoi (token);
      token = strtok (NULL, ".:");
      if (token)
	*heuristic = atoi (token);
      else
	*heuristic = 1;
      our_dealloc (kopieDummy);
      if (*heuristic == 0 && *fifo == 0)
        our_error ("At least one of the heuristic and fifo parameters for interleave must be non-zero!");
      return TRUE;
    }
    token = strtok (NULL, ":");
  }

  our_dealloc (kopieDummy);

  return FALSE;
}
